Index: uspace/lib/c/include/ipc/ipc.h
===================================================================
--- uspace/lib/c/include/ipc/ipc.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/ipc/ipc.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -34,5 +34,5 @@
 
 #if ((defined(LIBC_ASYNC_H_)) && (!defined(LIBC_ASYNC_C_)))
-#error Do not intermix low-level IPC interface and async framework
+	#error Do not intermix low-level IPC interface and async framework
 #endif
 
@@ -46,7 +46,7 @@
 #include <abi/cap.h>
 
-typedef void (*ipc_async_callback_t)(void *, errno_t, ipc_call_t *);
+typedef void (*ipc_async_callback_t)(void *, int, ipc_call_t *);
 
-extern errno_t ipc_wait_cycle(ipc_call_t *, sysarg_t, unsigned int);
+extern cap_handle_t ipc_wait_cycle(ipc_call_t *, sysarg_t, unsigned int);
 extern void ipc_poke(void);
 
@@ -54,6 +54,6 @@
 	ipc_wait_for_call_timeout(data, SYNCH_NO_TIMEOUT);
 
-extern errno_t ipc_wait_for_call_timeout(ipc_call_t *, sysarg_t);
-extern errno_t ipc_trywait_for_call(ipc_call_t *);
+extern cap_handle_t ipc_wait_for_call_timeout(ipc_call_t *, sysarg_t);
+extern cap_handle_t ipc_trywait_for_call(ipc_call_t *);
 
 /*
@@ -78,7 +78,7 @@
 	    (arg5))
 
-extern errno_t ipc_answer_fast(cap_handle_t, errno_t, sysarg_t, sysarg_t,
+extern sysarg_t ipc_answer_fast(cap_handle_t, sysarg_t, sysarg_t, sysarg_t,
     sysarg_t, sysarg_t);
-extern errno_t ipc_answer_slow(cap_handle_t, errno_t, sysarg_t, sysarg_t,
+extern sysarg_t ipc_answer_slow(cap_handle_t, sysarg_t, sysarg_t, sysarg_t,
     sysarg_t, sysarg_t, sysarg_t);
 
@@ -115,12 +115,12 @@
     sysarg_t, sysarg_t, sysarg_t, void *, ipc_async_callback_t);
 
-extern errno_t ipc_hangup(cap_handle_t);
+extern int ipc_hangup(cap_handle_t);
 
-extern errno_t ipc_forward_fast(cap_handle_t, cap_handle_t, sysarg_t, sysarg_t,
+extern int ipc_forward_fast(cap_handle_t, cap_handle_t, sysarg_t, sysarg_t,
     sysarg_t, unsigned int);
-extern errno_t ipc_forward_slow(cap_handle_t, cap_handle_t, sysarg_t, sysarg_t,
+extern int ipc_forward_slow(cap_handle_t, cap_handle_t, sysarg_t, sysarg_t,
     sysarg_t, sysarg_t, sysarg_t, sysarg_t, unsigned int);
 
-extern errno_t ipc_connect_kbox(task_id_t, cap_handle_t *);
+extern int ipc_connect_kbox(task_id_t);
 
 #endif
Index: uspace/lib/c/include/ipc/irq.h
===================================================================
--- uspace/lib/c/include/ipc/irq.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/ipc/irq.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -38,8 +38,7 @@
 #include <types/common.h>
 #include <abi/ddi/irq.h>
-#include <abi/cap.h>
 
-extern errno_t ipc_irq_subscribe(int, sysarg_t, const irq_code_t *, cap_handle_t *);
-extern errno_t ipc_irq_unsubscribe(cap_handle_t);
+extern int ipc_irq_subscribe(int, sysarg_t, const irq_code_t *);
+extern int ipc_irq_unsubscribe(int);
 
 #endif
Index: uspace/lib/c/include/ipc/tcp.h
===================================================================
--- uspace/lib/c/include/ipc/tcp.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/ipc/tcp.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2015 Jiri Svoboda
+ * Copyright (c) 2015 Jiri Svobda
  * All rights reserved.
  *
Index: uspace/lib/c/include/ipc/udp.h
===================================================================
--- uspace/lib/c/include/ipc/udp.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/ipc/udp.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2015 Jiri Svoboda
+ * Copyright (c) 2015 Jiri Svobda
  * All rights reserved.
  *
Index: uspace/lib/c/include/irc.h
===================================================================
--- uspace/lib/c/include/irc.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/irc.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,7 +36,7 @@
 #define LIBC_IRC_H_
 
-extern errno_t irc_enable_interrupt(int);
-extern errno_t irc_disable_interrupt(int);
-extern errno_t irc_clear_interrupt(int);
+extern int irc_enable_interrupt(int);
+extern int irc_disable_interrupt(int);
+extern int irc_clear_interrupt(int);
 
 #endif
Index: uspace/lib/c/include/loader/loader.h
===================================================================
--- uspace/lib/c/include/loader/loader.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/loader/loader.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,14 +43,14 @@
 typedef struct loader loader_t;
 
-extern errno_t loader_spawn(const char *);
+extern int loader_spawn(const char *);
 extern loader_t *loader_connect(void);
-extern errno_t loader_get_task_id(loader_t *, task_id_t *);
-extern errno_t loader_set_cwd(loader_t *);
-extern errno_t loader_set_program(loader_t *, const char *, int);
-extern errno_t loader_set_program_path(loader_t *, const char *);
-extern errno_t loader_set_args(loader_t *, const char *const[]);
-extern errno_t loader_add_inbox(loader_t *, const char *, int);
-extern errno_t loader_load_program(loader_t *);
-extern errno_t loader_run(loader_t *);
+extern int loader_get_task_id(loader_t *, task_id_t *);
+extern int loader_set_cwd(loader_t *);
+extern int loader_set_program(loader_t *, const char *, int);
+extern int loader_set_program_path(loader_t *, const char *);
+extern int loader_set_args(loader_t *, const char *const[]);
+extern int loader_add_inbox(loader_t *, const char *, int);
+extern int loader_load_program(loader_t *);
+extern int loader_run(loader_t *);
 extern void loader_abort(loader_t *);
 
Index: uspace/lib/c/include/loc.h
===================================================================
--- uspace/lib/c/include/loc.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/loc.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -46,19 +46,19 @@
 extern void loc_exchange_end(async_exch_t *);
 
-extern errno_t loc_server_register(const char *);
-extern errno_t loc_service_register(const char *, service_id_t *);
-extern errno_t loc_service_unregister(service_id_t);
-extern errno_t loc_service_add_to_cat(service_id_t, category_id_t);
+extern int loc_server_register(const char *);
+extern int loc_service_register(const char *, service_id_t *);
+extern int loc_service_unregister(service_id_t);
+extern int loc_service_add_to_cat(service_id_t, category_id_t);
 
-extern errno_t loc_service_get_id(const char *, service_id_t *,
+extern int loc_service_get_id(const char *, service_id_t *,
     unsigned int);
-extern errno_t loc_service_get_name(service_id_t, char **);
-extern errno_t loc_service_get_server_name(service_id_t, char **);
-extern errno_t loc_namespace_get_id(const char *, service_id_t *,
+extern int loc_service_get_name(service_id_t, char **);
+extern int loc_service_get_server_name(service_id_t, char **);
+extern int loc_namespace_get_id(const char *, service_id_t *,
     unsigned int);
-extern errno_t loc_category_get_id(const char *, category_id_t *,
+extern int loc_category_get_id(const char *, category_id_t *,
     unsigned int);
-extern errno_t loc_category_get_name(category_id_t, char **);
-extern errno_t loc_category_get_svcs(category_id_t, category_id_t **, size_t *);
+extern int loc_category_get_name(category_id_t, char **);
+extern int loc_category_get_svcs(category_id_t, category_id_t **, size_t *);
 extern loc_object_type_t loc_id_probe(service_id_t);
 
@@ -74,6 +74,6 @@
 extern size_t loc_get_namespaces(loc_sdesc_t **);
 extern size_t loc_get_services(service_id_t, loc_sdesc_t **);
-extern errno_t loc_get_categories(category_id_t **, size_t *);
-extern errno_t loc_register_cat_change_cb(loc_cat_change_cb_t);
+extern int loc_get_categories(category_id_t **, size_t *);
+extern int loc_register_cat_change_cb(loc_cat_change_cb_t);
 
 
Index: uspace/lib/c/include/malloc.h
===================================================================
--- uspace/lib/c/include/malloc.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/malloc.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -38,13 +38,13 @@
 #include <stddef.h>
 
-extern void *malloc(size_t size)
+extern void *malloc(const size_t size)
     __attribute__((malloc));
-extern void *calloc(size_t nmemb, size_t size)
+extern void *calloc(const size_t nmemb, const size_t size)
     __attribute__((malloc));
-extern void *memalign(size_t align, size_t size)
+extern void *memalign(const size_t align, const size_t size)
     __attribute__((malloc));
-extern void *realloc(void *addr, size_t size)
+extern void *realloc(const void *addr, const size_t size)
     __attribute__((warn_unused_result));
-extern void free(void *addr);
+extern void free(const void *addr);
 extern void *heap_check(void);
 
Index: uspace/lib/c/include/ns.h
===================================================================
--- uspace/lib/c/include/ns.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/ns.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,10 +40,10 @@
 #include <async.h>
 
-extern errno_t service_register(service_t);
+extern int service_register(service_t);
 extern async_sess_t *service_connect(service_t, iface_t, sysarg_t);
 extern async_sess_t *service_connect_blocking(service_t, iface_t, sysarg_t);
 
-extern errno_t ns_ping(void);
-extern errno_t ns_intro(task_id_t);
+extern int ns_ping(void);
+extern int ns_intro(task_id_t);
 extern async_sess_t *ns_session_get(void);
 
Index: uspace/lib/c/include/perm.h
===================================================================
--- uspace/lib/c/include/perm.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/perm.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -38,6 +38,6 @@
 #include <task.h>
 
-extern errno_t perm_grant(task_id_t, unsigned int);
-extern errno_t perm_revoke(task_id_t, unsigned int);
+extern int perm_grant(task_id_t, unsigned int);
+extern int perm_revoke(task_id_t, unsigned int);
 
 #endif
Index: uspace/lib/c/include/rtld/module.h
===================================================================
--- uspace/lib/c/include/rtld/module.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/rtld/module.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,5 +41,5 @@
 #include <types/rtld/rtld.h>
 
-extern errno_t module_create_static_exec(rtld_t *, module_t **);
+extern int module_create_static_exec(rtld_t *, module_t **);
 extern void module_process_relocs(module_t *);
 extern module_t *module_find(rtld_t *, const char *);
Index: uspace/lib/c/include/rtld/rtld.h
===================================================================
--- uspace/lib/c/include/rtld/rtld.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/rtld/rtld.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -45,6 +45,6 @@
 extern rtld_t *runtime_env;
 
-extern errno_t rtld_init_static(void);
-extern errno_t rtld_prog_process(elf_finfo_t *, rtld_t **);
+extern int rtld_init_static(void);
+extern int rtld_prog_process(elf_finfo_t *, rtld_t **);
 extern tcb_t *rtld_tls_make(rtld_t *);
 extern unsigned long rtld_get_next_id(rtld_t *);
Index: uspace/lib/c/include/smc.h
===================================================================
--- uspace/lib/c/include/smc.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/smc.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -38,5 +38,5 @@
 #include <stddef.h>
 
-extern errno_t smc_coherence(void *address, size_t size);
+extern int smc_coherence(void *address, size_t size);
 
 #endif
Index: uspace/lib/c/include/stacktrace.h
===================================================================
--- uspace/lib/c/include/stacktrace.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/stacktrace.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -37,10 +37,9 @@
 #define LIBC_STACKTRACE_H_
 
-#include <errno.h>
 #include <stdint.h>
 #include <stdbool.h>
 
 typedef struct {
-	errno_t (*read_uintptr)(void *, uintptr_t, uintptr_t *);
+	int (*read_uintptr)(void *, uintptr_t, uintptr_t *);
 } stacktrace_ops_t;
 
@@ -59,6 +58,6 @@
  */
 extern bool stacktrace_fp_valid(stacktrace_t *, uintptr_t);
-extern errno_t stacktrace_fp_prev(stacktrace_t *, uintptr_t, uintptr_t *);
-extern errno_t stacktrace_ra_get(stacktrace_t *, uintptr_t, uintptr_t *);
+extern int stacktrace_fp_prev(stacktrace_t *, uintptr_t, uintptr_t *);
+extern int stacktrace_ra_get(stacktrace_t *, uintptr_t, uintptr_t *);
 
 extern void stacktrace_prepare(void);
Index: uspace/lib/c/include/stdio.h
===================================================================
--- uspace/lib/c/include/stdio.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/stdio.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -37,7 +37,7 @@
 
 #include <stdarg.h>
+#include <str.h>
 #include <io/verify.h>
-#include <_bits/size_t.h>
-#include <_bits/wchar_t.h>
+#include <abi/kio.h>
 
 #define EOF  (-1)
@@ -58,76 +58,11 @@
 #define BUFSIZ  4096
 
-/** Forward declaration */
-struct _IO_FILE;
-typedef struct _IO_FILE FILE;
-
-extern FILE *stdin;
-extern FILE *stdout;
-extern FILE *stderr;
-
-/* Character and string input functions */
-extern int fgetc(FILE *);
-extern char *fgets(char *, int, FILE *);
-
-extern int getchar(void);
-
-/* Character and string output functions */
-extern int fputc(wchar_t, FILE *);
-extern int fputs(const char *, FILE *);
-
-extern int putchar(wchar_t);
-extern int puts(const char *);
-
-extern int ungetc(int, FILE *);
-
-/* Formatted string output functions */
-extern int fprintf(FILE *, const char*, ...)
-    _HELENOS_PRINTF_ATTRIBUTE(2, 3);
-extern int vfprintf(FILE *, const char *, va_list);
-
-extern int printf(const char *, ...)
-    _HELENOS_PRINTF_ATTRIBUTE(1, 2);
-extern int vprintf(const char *, va_list);
-
-extern int snprintf(char *, size_t , const char *, ...)
-    _HELENOS_PRINTF_ATTRIBUTE(3, 4);
-extern int vasprintf(char **, const char *, va_list);
-extern int asprintf(char **, const char *, ...)
-    _HELENOS_PRINTF_ATTRIBUTE(2, 3);
-extern int vsnprintf(char *, size_t, const char *, va_list);
-
-/* File stream functions */
-extern FILE *fopen(const char *, const char *);
-extern FILE *freopen(const char *, const char *, FILE *);
-extern int fclose(FILE *);
-
-extern size_t fread(void *, size_t, size_t, FILE *);
-extern size_t fwrite(const void *, size_t, size_t, FILE *);
-
-extern int fseek(FILE *, long, int);
-extern void rewind(FILE *);
-extern long ftell(FILE *);
-extern int feof(FILE *);
-
-extern int fflush(FILE *);
-extern int ferror(FILE *);
-extern void clearerr(FILE *);
-
-extern void setvbuf(FILE *, void *, int, size_t);
-extern void setbuf(FILE *, void *);
-
-/* Misc file functions */
-extern int rename(const char *, const char *);
-extern int remove(const char *);
-
-#ifndef _HELENOS_SOURCE
-#define _IONBF 0
-#define _IOLBF 1
-#define _IOFBF 2
-#endif
-
-#ifdef _HELENOS_SOURCE
-
-/* Nonstandard extensions. */
+#define DEBUG(fmt, ...) \
+	{ \
+		char _buf[256]; \
+		int _n = snprintf(_buf, sizeof(_buf), fmt, ##__VA_ARGS__); \
+		if (_n > 0) \
+			(void) __SYSCALL3(SYS_KIO, KIO_WRITE, (sysarg_t) _buf, str_size(_buf)); \
+	}
 
 enum _buffer_type {
@@ -151,18 +86,73 @@
 };
 
-extern int vprintf_size(const char *, va_list);
-extern int printf_size(const char *, ...)
-    _HELENOS_PRINTF_ATTRIBUTE(1, 2);
-extern FILE *fdopen(int, const char *);
-extern int fileno(FILE *);
+/** Forward declaration */
+struct _IO_FILE;
+typedef struct _IO_FILE FILE;
+
+extern FILE *stdin;
+extern FILE *stdout;
+extern FILE *stderr;
+
+/* Character and string input functions */
+extern int fgetc(FILE *);
+extern char *fgets(char *, int, FILE *);
+
+extern int getchar(void);
 extern char *gets(char *, size_t);
 
-#include <offset.h>
+/* Character and string output functions */
+extern int fputc(wchar_t, FILE *);
+extern int fputs(const char *, FILE *);
 
-extern int fseek64(FILE *, off64_t, int);
-extern off64_t ftell64(FILE *);
+extern int putchar(wchar_t);
+extern int puts(const char *);
 
-#endif
+extern int ungetc(int, FILE *);
 
+/* Formatted string output functions */
+extern int fprintf(FILE *, const char*, ...)
+    PRINTF_ATTRIBUTE(2, 3);
+extern int vfprintf(FILE *, const char *, va_list);
+
+extern int printf(const char *, ...)
+    PRINTF_ATTRIBUTE(1, 2);
+extern int vprintf(const char *, va_list);
+
+extern int snprintf(char *, size_t , const char *, ...)
+    PRINTF_ATTRIBUTE(3, 4);
+extern int vasprintf(char **, const char *, va_list);
+extern int asprintf(char **, const char *, ...)
+    PRINTF_ATTRIBUTE(2, 3);
+extern int vsnprintf(char *, size_t, const char *, va_list);
+
+extern int printf_size(const char *, ...)
+    PRINTF_ATTRIBUTE(1, 2);
+extern int vprintf_size(const char *, va_list);
+
+/* File stream functions */
+extern FILE *fopen(const char *, const char *);
+extern FILE *fdopen(int, const char *);
+extern FILE *freopen(const char *, const char *, FILE *);
+extern int fclose(FILE *);
+
+extern size_t fread(void *, size_t, size_t, FILE *);
+extern size_t fwrite(const void *, size_t, size_t, FILE *);
+
+extern int fseek(FILE *, long, int);
+extern void rewind(FILE *);
+extern long ftell(FILE *);
+extern int feof(FILE *);
+extern int fileno(FILE *);
+
+extern int fflush(FILE *);
+extern int ferror(FILE *);
+extern void clearerr(FILE *);
+
+extern void setvbuf(FILE *, void *, int, size_t);
+extern void setbuf(FILE *, void *);
+
+/* Misc file functions */
+extern int rename(const char *, const char *);
+extern int remove(const char *);
 
 #endif
Index: uspace/lib/c/include/stdlib.h
===================================================================
--- uspace/lib/c/include/stdlib.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/stdlib.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -42,18 +42,12 @@
 #define RAND_MAX  714025
 
-extern int rand(void);
-extern void srand(unsigned int seed);
+#define rand()       random()
+#define srand(seed)  srandom(seed)
+
+extern long int random(void);
+extern void srandom(unsigned int seed);
 
 extern void abort(void) __attribute__((noreturn));
 extern void exit(int) __attribute__((noreturn));
-
-extern int atoi(const char *);
-extern long atol(const char *);
-extern long long atoll(const char *);
-
-extern long strtol(const char *__restrict__, char **__restrict__, int);
-extern long long strtoll(const char *__restrict__, char **__restrict__, int);
-extern unsigned long strtoul(const char *__restrict__, char **__restrict__, int);
-extern unsigned long long strtoull(const char *__restrict__, char **__restrict__, int);
 
 #endif
Index: uspace/lib/c/include/str.h
===================================================================
--- uspace/lib/c/include/str.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/str.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -37,5 +37,4 @@
 #define LIBC_STR_H_
 
-#include <errno.h>
 #include <mem.h>
 #include <stddef.h>
@@ -59,5 +58,5 @@
 extern wchar_t str_decode(const char *str, size_t *offset, size_t sz);
 extern wchar_t str_decode_reverse(const char *str, size_t *offset, size_t sz);
-extern errno_t chr_encode(const wchar_t ch, char *str, size_t *offset, size_t sz);
+extern int chr_encode(const wchar_t ch, char *str, size_t *offset, size_t sz);
 
 extern size_t str_size(const char *str);
@@ -93,11 +92,11 @@
 extern void str_append(char *dest, size_t size, const char *src);
 
-extern errno_t spascii_to_str(char *dest, size_t size, const uint8_t *src, size_t n);
+extern int spascii_to_str(char *dest, size_t size, const uint8_t *src, size_t n);
 extern void wstr_to_str(char *dest, size_t size, const wchar_t *src);
 extern char *wstr_to_astr(const wchar_t *src);
 extern void str_to_wstr(wchar_t *dest, size_t dlen, const char *src);
 extern wchar_t *str_to_awstr(const char *src);
-extern errno_t utf16_to_str(char *dest, size_t size, const uint16_t *src);
-extern errno_t str_to_utf16(uint16_t *dest, size_t dlen, const char *src);
+extern int utf16_to_str(char *dest, size_t size, const uint16_t *src);
+extern int str_to_utf16(uint16_t *dest, size_t dlen, const char *src);
 extern size_t utf16_wsize(const uint16_t *ustr);
 
@@ -116,13 +115,13 @@
 extern char *str_tok(char *, const char *, char **);
 
-extern errno_t str_uint8_t(const char *, const char **, unsigned int, bool,
+extern int str_uint8_t(const char *, const char **, unsigned int, bool,
     uint8_t *);
-extern errno_t str_uint16_t(const char *, const char **, unsigned int, bool,
+extern int str_uint16_t(const char *, const char **, unsigned int, bool,
     uint16_t *);
-extern errno_t str_uint32_t(const char *, const char **, unsigned int, bool,
+extern int str_uint32_t(const char *, const char **, unsigned int, bool,
     uint32_t *);
-extern errno_t str_uint64_t(const char *, const char **, unsigned int, bool,
+extern int str_uint64_t(const char *, const char **, unsigned int, bool,
     uint64_t *);
-extern errno_t str_size_t(const char *, const char **, unsigned int, bool,
+extern int str_size_t(const char *, const char **, unsigned int, bool,
     size_t *);
 
Index: uspace/lib/c/include/sys/time.h
===================================================================
--- uspace/lib/c/include/sys/time.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/sys/time.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -38,5 +38,4 @@
 #define LIBC_SYS_TIME_H_
 
-#include <errno.h>
 #include <stddef.h>
 #include <stdint.h>
@@ -84,13 +83,13 @@
 
 extern void udelay(useconds_t);
-extern errno_t usleep(useconds_t);
+extern int usleep(useconds_t);
 
 extern time_t mktime(struct tm *);
-extern errno_t time_utc2tm(const time_t, struct tm *);
-extern errno_t time_utc2str(const time_t, char *);
+extern int time_utc2tm(const time_t, struct tm *);
+extern int time_utc2str(const time_t, char *);
 extern void time_tm2str(const struct tm *, char *);
-extern errno_t time_tv2tm(const struct timeval *, struct tm *);
-extern errno_t time_local2tm(const time_t, struct tm *);
-extern errno_t time_local2str(const time_t, char *);
+extern int time_tv2tm(const struct timeval *, struct tm *);
+extern int time_local2tm(const time_t, struct tm *);
+extern int time_local2str(const time_t, char *);
 extern double difftime(time_t, time_t);
 extern size_t strftime(char *__restrict__, size_t, const char *__restrict__,
Index: uspace/lib/c/include/sysinfo.h
===================================================================
--- uspace/lib/c/include/sysinfo.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/sysinfo.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,5 +43,5 @@
 extern char *sysinfo_get_keys(const char *, size_t *);
 extern sysinfo_item_val_type_t sysinfo_get_val_type(const char *);
-extern errno_t sysinfo_get_value(const char *, sysarg_t *);
+extern int sysinfo_get_value(const char *, sysarg_t *);
 extern void *sysinfo_get_data(const char *, size_t *);
 extern void *sysinfo_get_property(const char *, const char *, size_t *);
Index: uspace/lib/c/include/task.h
===================================================================
--- uspace/lib/c/include/task.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/task.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -51,21 +51,21 @@
 
 extern task_id_t task_get_id(void);
-extern errno_t task_set_name(const char *);
-extern errno_t task_kill(task_id_t);
+extern int task_set_name(const char *);
+extern int task_kill(task_id_t);
 
-extern errno_t task_spawnv(task_id_t *, task_wait_t *, const char *path,
+extern int task_spawnv(task_id_t *, task_wait_t *, const char *path,
     const char *const []);
-extern errno_t task_spawnvf(task_id_t *, task_wait_t *, const char *path,
+extern int task_spawnvf(task_id_t *, task_wait_t *, const char *path,
     const char *const [], int, int, int);
-extern errno_t task_spawn(task_id_t *, task_wait_t *, const char *path, int,
+extern int task_spawn(task_id_t *, task_wait_t *, const char *path, int,
     va_list ap);
-extern errno_t task_spawnl(task_id_t *, task_wait_t *, const char *path, ...)
+extern int task_spawnl(task_id_t *, task_wait_t *, const char *path, ...)
     __attribute__((sentinel));
 
-extern errno_t task_setup_wait(task_id_t, task_wait_t *);
+extern int task_setup_wait(task_id_t, task_wait_t *);
 extern void task_cancel_wait(task_wait_t *);
-extern errno_t task_wait(task_wait_t *, task_exit_t *, int *);
-extern errno_t task_wait_task_id(task_id_t, task_exit_t *, int *);
-extern errno_t task_retval(int);
+extern int task_wait(task_wait_t *, task_exit_t *, int *);
+extern int task_wait_task_id(task_id_t, task_exit_t *, int *);
+extern int task_retval(int);
 
 #endif
Index: uspace/lib/c/include/thread.h
===================================================================
--- uspace/lib/c/include/thread.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/thread.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,5 +36,4 @@
 #define LIBC_THREAD_H_
 
-#include <errno.h>
 #include <libarch/thread.h>
 #include <stdint.h>
@@ -42,8 +41,8 @@
 #include <time.h>
 
-extern errno_t thread_create(void (*)(void *), void *, const char *, thread_id_t *);
+extern int thread_create(void (*)(void *), void *, const char *, thread_id_t *);
 extern void thread_exit(int) __attribute__((noreturn));
 extern void thread_detach(thread_id_t);
-extern errno_t thread_join(thread_id_t);
+extern int thread_join(thread_id_t);
 extern thread_id_t thread_get_id(void);
 extern int thread_usleep(useconds_t);
Index: uspace/lib/c/include/types/common.h
===================================================================
--- uspace/lib/c/include/types/common.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/types/common.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -45,5 +45,4 @@
 
 #include <_bits/all.h>
-#include <_bits/errno.h>
 
 #endif
Index: uspace/lib/c/include/types/inet.h
===================================================================
--- uspace/lib/c/include/types/inet.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/types/inet.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -54,5 +54,5 @@
 
 typedef struct {
-	errno_t (*recv)(inet_dgram_t *);
+	int (*recv)(inet_dgram_t *);
 } inet_ev_ops_t;
 
Index: uspace/lib/c/include/udebug.h
===================================================================
--- uspace/lib/c/include/udebug.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/udebug.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,19 +43,19 @@
 typedef sysarg_t thash_t;
 
-extern errno_t udebug_begin(async_sess_t *);
-extern errno_t udebug_end(async_sess_t *);
-extern errno_t udebug_set_evmask(async_sess_t *, udebug_evmask_t);
-extern errno_t udebug_thread_read(async_sess_t *, void *, size_t, size_t *,
+extern int udebug_begin(async_sess_t *);
+extern int udebug_end(async_sess_t *);
+extern int udebug_set_evmask(async_sess_t *, udebug_evmask_t);
+extern int udebug_thread_read(async_sess_t *, void *, size_t , size_t *,
     size_t *);
-extern errno_t udebug_name_read(async_sess_t *, void *, size_t, size_t *,
+extern int udebug_name_read(async_sess_t *, void *, size_t, size_t *,
     size_t *);
-extern errno_t udebug_areas_read(async_sess_t *, void *, size_t, size_t *,
+extern int udebug_areas_read(async_sess_t *, void *, size_t, size_t *,
     size_t *);
-extern errno_t udebug_mem_read(async_sess_t *, void *, uintptr_t, size_t);
-extern errno_t udebug_args_read(async_sess_t *, thash_t, sysarg_t *);
-extern errno_t udebug_regs_read(async_sess_t *, thash_t, void *);
-extern errno_t udebug_go(async_sess_t *, thash_t, udebug_event_t *, sysarg_t *,
+extern int udebug_mem_read(async_sess_t *, void *, uintptr_t, size_t);
+extern int udebug_args_read(async_sess_t *, thash_t, sysarg_t *);
+extern int udebug_regs_read(async_sess_t *, thash_t, void *);
+extern int udebug_go(async_sess_t *, thash_t, udebug_event_t *, sysarg_t *,
     sysarg_t *);
-extern errno_t udebug_stop(async_sess_t *, thash_t);
+extern int udebug_stop(async_sess_t *, thash_t);
 
 #endif
Index: uspace/lib/c/include/uuid.h
===================================================================
--- uspace/lib/c/include/uuid.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/uuid.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,9 +39,9 @@
 #include <types/uuid.h>
 
-extern errno_t uuid_generate(uuid_t *);
+extern int uuid_generate(uuid_t *);
 extern void uuid_encode(uuid_t *, uint8_t *);
 extern void uuid_decode(uint8_t *, uuid_t *);
-extern errno_t uuid_parse(const char *, uuid_t *, const char **);
-extern errno_t uuid_format(uuid_t *, char **);
+extern int uuid_parse(const char *, uuid_t *, const char **);
+extern int uuid_format(uuid_t *, char **);
 
 #endif
Index: uspace/lib/c/include/vbd.h
===================================================================
--- uspace/lib/c/include/vbd.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/c/include/vbd.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -95,18 +95,18 @@
 typedef sysarg_t vbd_part_id_t;
 
-extern errno_t vbd_create(vbd_t **);
+extern int vbd_create(vbd_t **);
 extern void vbd_destroy(vbd_t *);
-extern errno_t vbd_get_disks(vbd_t *, service_id_t **, size_t *);
-extern errno_t vbd_disk_info(vbd_t *, service_id_t, vbd_disk_info_t *);
-extern errno_t vbd_label_create(vbd_t *, service_id_t, label_type_t);
-extern errno_t vbd_label_delete(vbd_t *, service_id_t);
-extern errno_t vbd_label_get_parts(vbd_t *, service_id_t, service_id_t **,
+extern int vbd_get_disks(vbd_t *, service_id_t **, size_t *);
+extern int vbd_disk_info(vbd_t *, service_id_t, vbd_disk_info_t *);
+extern int vbd_label_create(vbd_t *, service_id_t, label_type_t);
+extern int vbd_label_delete(vbd_t *, service_id_t);
+extern int vbd_label_get_parts(vbd_t *, service_id_t, service_id_t **,
     size_t *);
-extern errno_t vbd_part_get_info(vbd_t *, vbd_part_id_t, vbd_part_info_t *);
-extern errno_t vbd_part_create(vbd_t *, service_id_t, vbd_part_spec_t *,
+extern int vbd_part_get_info(vbd_t *, vbd_part_id_t, vbd_part_info_t *);
+extern int vbd_part_create(vbd_t *, service_id_t, vbd_part_spec_t *,
     vbd_part_id_t *);
-extern errno_t vbd_part_delete(vbd_t *, vbd_part_id_t);
+extern int vbd_part_delete(vbd_t *, vbd_part_id_t);
 extern void vbd_pspec_init(vbd_part_spec_t *);
-extern errno_t vbd_suggest_ptype(vbd_t *, service_id_t, label_pcnt_t,
+extern int vbd_suggest_ptype(vbd_t *, service_id_t, label_pcnt_t,
     label_ptype_t *);
 
